#include "stdafx.h"
#include "SerialPort.h"  
#include <process.h>  
#include <iostream>  

/** ߳˳־ */
bool CSerialPort::s_bExit = false;
/** ʱ,sleep´βѯʱ,λ: */
const UINT SLEEP_TIME_INTERVAL = 5;

CSerialPort::CSerialPort(void)
: m_hListenThread(INVALID_HANDLE_VALUE)
{
	m_hComm = INVALID_HANDLE_VALUE;
	m_hListenThread = INVALID_HANDLE_VALUE;

	InitializeCriticalSection(&m_csCommunicationSync);
}

CSerialPort::~CSerialPort(void)
{
	CloseListenThread();
	ClosePort();
	DeleteCriticalSection(&m_csCommunicationSync);
}

bool CSerialPort::InitPort(UINT portNo /*= 1*/, UINT baud /*= CBR_9600*/, char parity /*= 'N'*/,
	UINT databits /*= 8*/, UINT stopsbits /*= 1*/, DWORD dwCommEvents /*= EV_RXCHAR*/)
{

	/** ʱ,ƶתΪַʽ,ԹDCBṹ */
	char szDCBparam[50];
	sprintf_s(szDCBparam, "baud=%d parity=%c data=%d stop=%d", baud, parity, databits, stopsbits);
	//printf("baud = %d parity = %c data = %d stop = %d\n", baud, parity, databits, stopsbits);

	/** ָ,úڲѾٽ,벻Ҫӱ */
	if (!OpenPort(portNo))
	{
		return false;
	}
	//printf("OpenPort %d sucussfully!\n");

	/** ٽ */
	EnterCriticalSection(&m_csCommunicationSync);

	/** Ƿд */
	BOOL bIsSuccess = TRUE;

	/** ڴ˿ĻС,,ϵͳĬֵ.
	*  ԼûСʱ,ҪעԴһЩ,⻺
	*/
	/*if (bIsSuccess )
	{
	bIsSuccess = SetupComm(m_hComm,10,10);
	}*/

	/** ôڵĳʱʱ䣬0 ʾʹóʱƣֵΪʱֵ */
	COMMTIMEOUTS  CommTimeouts;
	CommTimeouts.ReadIntervalTimeout = 1000;
	CommTimeouts.ReadTotalTimeoutMultiplier = 500;
	CommTimeouts.ReadTotalTimeoutConstant = 5000;
	CommTimeouts.WriteTotalTimeoutMultiplier = 500;
	CommTimeouts.WriteTotalTimeoutConstant = 2000;
	if (bIsSuccess)
	{
		bIsSuccess = SetCommTimeouts(m_hComm, &CommTimeouts);
	}

	DCB  dcb;
	if (bIsSuccess)
	{
		// ANSIַתΪUNICODEַ  
		DWORD dwNum = MultiByteToWideChar(CP_ACP, 0, szDCBparam, -1, NULL, 0);
		wchar_t *pwText = new wchar_t[dwNum];
		if (!MultiByteToWideChar(CP_ACP, 0, szDCBparam, -1, pwText, dwNum))
		{
			bIsSuccess = TRUE;
		}

		/** ȡǰò,ҹ촮DCB */
		bIsSuccess = GetCommState(m_hComm, &dcb) && BuildCommDCB(pwText, &dcb);
		/** RTS flow */
		dcb.fRtsControl = RTS_CONTROL_ENABLE;

		/** ͷڴռ */
		delete[] pwText;
	}

	if (bIsSuccess)
	{
		/** ʹDCBô״̬ */
		bIsSuccess = SetCommState(m_hComm, &dcb);
	}

	/**  մڻ */
	PurgeComm(m_hComm, PURGE_RXCLEAR | PURGE_TXCLEAR | PURGE_RXABORT | PURGE_TXABORT);

	/** 뿪ٽ */
	LeaveCriticalSection(&m_csCommunicationSync);

	return bIsSuccess == TRUE;
}

bool CSerialPort::InitPort(UINT portNo, const LPDCB& plDCB)
{
	/** ָ,úڲѾٽ,벻Ҫӱ */
	if (!OpenPort(portNo))
	{
		return false;
	}

	/** ٽ */
	EnterCriticalSection(&m_csCommunicationSync);

	/** ôڲ */
	if (!SetCommState(m_hComm, plDCB))
	{
		return false;
	}

	/**  մڻ */
	PurgeComm(m_hComm, PURGE_RXCLEAR | PURGE_TXCLEAR | PURGE_RXABORT | PURGE_TXABORT);

	/** 뿪ٽ */
	LeaveCriticalSection(&m_csCommunicationSync);

	return true;
}

void CSerialPort::ClosePort()
{
	/** дڱ򿪣ر */
	if (m_hComm != INVALID_HANDLE_VALUE)
	{
		CloseHandle(m_hComm);
		m_hComm = INVALID_HANDLE_VALUE;
	}
	//printf("Port Closed!\n");
}

bool CSerialPort::OpenPort(UINT portNo)
{
	/** ٽ */
	EnterCriticalSection(&m_csCommunicationSync);

	/** ѴڵıתΪ豸 */
	char szPort[50];
	if (portNo > 9) {
		sprintf_s(szPort, "\\\\.\\COM%d", portNo);
	} else {
		sprintf_s(szPort, "COM%d", portNo);
	}
	//Ѵ򿪾͹ص
	if (m_hComm != INVALID_HANDLE_VALUE)
	{
		CloseHandle(m_hComm);
		m_hComm = INVALID_HANDLE_VALUE;
	}

	/** ָĴ */
	m_hComm = CreateFileA(szPort,  /** 豸,COM1,COM2 */
		GENERIC_READ | GENERIC_WRITE, /** ģʽ,ͬʱд */
		0,                            /** ģʽ,0ʾ */
		NULL,                         /** ȫ,һʹNULL */
		OPEN_EXISTING,                /** òʾ豸,򴴽ʧ */
		0,
		0);

	/** ʧܣͷԴ */
	if (m_hComm == INVALID_HANDLE_VALUE)
	{
		LeaveCriticalSection(&m_csCommunicationSync);
		//ڴʧܣʾϢ
#ifdef __REPORT_ERROR__
		DWORD error = GetLastError();
		switch (error)
		{
			//ڲ
			case ERROR_FILE_NOT_FOUND:
			{
				TCHAR Temp[200] = { 0 };
				_stprintf_s(Temp, 200, _T("COM%d ERROR_FILE_NOT_FOUND, Error Code:%d"), szPort, error);
				MessageBox(NULL, Temp, _T("COM InitPort Error"), MB_ICONERROR);
				break;
			}
			//ھܾ
			case ERROR_ACCESS_DENIED:
			{
				TCHAR Temp[200] = { 0 };
				_stprintf_s(Temp, 200, _T("COM%d ERROR_ACCESS_DENIED, Error Code:%d"), szPort, error);
				MessageBox(NULL, Temp, _T("COM InitPort Error"), MB_ICONERROR);
				break;
			}
			default:
				break;
		}
#endif
		return false;
	}

	/** ˳ٽ */
	LeaveCriticalSection(&m_csCommunicationSync);
	//printf("Port Opened!\n");

	return true;
}

bool CSerialPort::OpenListenThread()
{
	/** ߳ǷѾ */
	if (m_hListenThread != INVALID_HANDLE_VALUE)
	{
		/** ߳Ѿ */
		return false;
	}

	s_bExit = false;
	/** ߳ID */
	UINT threadId;
	/** ݼ߳ */
	m_hListenThread = (HANDLE)_beginthreadex(NULL, 0, ListenThread, this, 0, &threadId);
	if (!m_hListenThread)
	{
		return false;
	}
	/** ̵߳ȼ,ͨ߳ */
	if (!SetThreadPriority(m_hListenThread, THREAD_PRIORITY_ABOVE_NORMAL))
	{
		return false;
	}

	return true;
}

bool CSerialPort::CloseListenThread()
{
	if (m_hListenThread != INVALID_HANDLE_VALUE)
	{
		/** ֪ͨ߳˳ */
		s_bExit = true;

		/** ȴ߳˳ */
		Sleep(10);

		/** ߳̾Ч */
		CloseHandle(m_hListenThread);
		m_hListenThread = INVALID_HANDLE_VALUE;
	}
	return true;
}

UINT CSerialPort::GetBytesInCOM()
{
	DWORD dwError = 0;  /**  */
	COMSTAT  comstat;   /** COMSTATṹ,¼ͨ豸״̬Ϣ */
	memset(&comstat, 0, sizeof(COMSTAT));

	UINT BytesInQue = 0;
	/** ڵReadFileWriteFile֮ǰ,ͨǰĴ־ */
	if (ClearCommError(m_hComm, &dwError, &comstat))
	{
		BytesInQue = comstat.cbInQue; /** ȡ뻺еֽ */
	}

	return BytesInQue;
}

UINT WINAPI CSerialPort::ListenThread(void* pParam)
{
	/** õָ */
	CSerialPort *pSerialPort = reinterpret_cast<CSerialPort*>(pParam);

	// ߳ѭ,ѯʽȡ  
	while (!pSerialPort->s_bExit)
	{
		UINT BytesInQue = pSerialPort->GetBytesInCOM();
		/** 뻺,Ϣһٲѯ */
		if (BytesInQue == 0)
		{
			Sleep(SLEEP_TIME_INTERVAL);
			continue;
		}
		//printf("BytesInQue: %d\n", BytesInQue);

		/** ȡ뻺еݲʾ */
		unsigned char result[256];
		if (pSerialPort->ReadData(result, BytesInQue) == true)
		{
			// ȡݳɹ
			//pSerialPort->s_bExit = true;
		}
	}

	return 0;
}

bool CSerialPort::ReadChar(char &cRecved)
{
	BOOL  bResult = TRUE;
	DWORD BytesRead = 0;
	if (m_hComm == INVALID_HANDLE_VALUE)
	{
		return false;
	}

	/** ٽ */
	EnterCriticalSection(&m_csCommunicationSync);

	/** ӻȡһֽڵ */
	bResult = ReadFile(m_hComm, &cRecved, 1, &BytesRead, NULL);
	if ((!bResult))
	{
		/** ȡ,Ըݸôԭ */
		DWORD dwError = GetLastError();

		/** մڻ */
		PurgeComm(m_hComm, PURGE_RXCLEAR | PURGE_RXABORT);
		LeaveCriticalSection(&m_csCommunicationSync);

		return false;
	}

	/** 뿪ٽ */
	LeaveCriticalSection(&m_csCommunicationSync);

	return (BytesRead == 1);

}

bool CSerialPort::WriteData(unsigned char* pData, unsigned int length)
{
	BOOL   bResult = TRUE;
	DWORD  BytesToSend = 0;
	if (m_hComm == INVALID_HANDLE_VALUE)
	{
		return false;
	}

	/** ٽ */
	EnterCriticalSection(&m_csCommunicationSync);

	/** 򻺳дָ */
	bResult = WriteFile(m_hComm, pData, length, &BytesToSend, NULL);
	if (!bResult)
	{
		DWORD dwError = GetLastError();
		/** մڻ */
		PurgeComm(m_hComm, PURGE_RXCLEAR | PURGE_RXABORT);
		LeaveCriticalSection(&m_csCommunicationSync);

		return false;
	}

	/** 뿪ٽ */
	LeaveCriticalSection(&m_csCommunicationSync);

#ifdef _DEBUG
	printf("SEND[%3d]: ", length);
	for (unsigned int i = 0; i < length; ++i)
		printf((i == 0) ? "%02X" : "-%02X", pData[i]);
	printf("\n");
#endif

	return true;
}

bool CSerialPort::ReadData(unsigned char* pData, unsigned int length)
{
	BOOL  bResult = TRUE;
	DWORD BytesRead = 0;
	if (m_hComm == INVALID_HANDLE_VALUE)
	{
		return false;
	}

	/** ٽ */
	EnterCriticalSection(&m_csCommunicationSync);

	/** ӻȡָ */
	bResult = ReadFile(m_hComm, pData, length, &BytesRead, NULL);
	if ((!bResult))
	{
		/** ȡ,Ըݸôԭ */
		DWORD dwError = GetLastError();

		/** մڻ */
		PurgeComm(m_hComm, PURGE_RXCLEAR | PURGE_RXABORT);
		LeaveCriticalSection(&m_csCommunicationSync);

		return false;
	}

	/** 뿪ٽ */
	LeaveCriticalSection(&m_csCommunicationSync);

#ifdef _DEBUG
	printf("RECV[%3d]: ", length);
	for (unsigned int i = 0; i < length; ++i)
		printf((i == 0) ? "%02X" : "-%02X", pData[i]);
	printf("\n");
#endif

	return (BytesRead == length);
}